Subject: [Last-Call] Rtgdir last call review of draft-ietf-detnet-mpls-04

From: Carlos Pignataro via Datatracker <[email-masked]>
Date: Mon, 23 Dec 2019 16:03:14 -0800

Reviewer: Carlos Pignataro
Review result: Has Issues

Hello,

I have been selected as the Routing Directorate reviewer for this draft. The
Routing Directorate seeks to review all routing or routing-related drafts as
they pass through IETF last call and IESG review, and sometimes on special
request. The purpose of the review is to provide assistance to the Routing ADs.
For more information about the Routing Directorate, please see
​http://trac.tools.ietf.org/area/rtg/trac/wiki/RtgDir

Although these comments are primarily for the use of the Routing ADs, it would
be helpful if you could consider them along with any other IETF Last Call
comments that you receive, and strive to resolve them through discussion or by
updating the draft.

Document: draft-ietf-detnet-mpls-04
Reviewer: Carlos Pignataro
Review Date: December 2019
Intended Status: Proposed Standard

Summary:

I have some minor concerns about this document that I think should be resolved
before publication.

[Resolving, in this context, means discussing and responding to, some of these
would and others would not imply changes]

This document specifies the Deterministic Networking data plane when operating
over an MPLS Packet Switched Networks.

Major Issues:

Minor Issues:

The document lists 7 (i.e, more than 5) authors.

A am somewhat confused regarding how some of these DETNET dataplane documents
interact, interface, and intersect with each other. Where are requirements
ultimately coming from for any variety of dataplanes? Specifically: *
draft-ietf-detnet-data-plane-framework-03 targets Informational (should be
STD?) but seems to include foundational Reqs. * draft-ietf-detnet-ip for IP *
draft-ietf-detnet-ip-over-mpls for IP over MPLS * draft-ietf-detnet-ip-over-tsn
and draft-ietf-detnet-mpls-over-tsn for X over TSN *
draft-ietf-detnet-mpls-over-udp-ip and draft-ietf-detnet-mpls for MPLS Among
all of these, where are really the requirements for MPLS? and for IP? Is there
a "Roadmap" or Rosetta Stone to understand these? There are many permutations
of X-over-Y. I appreciate that, not having followed DETNET discussions, I am
likely missing something.

3.1.  Layers of DetNet Data Plane

   The DetNet control word (d-CW)
   conforms to the Generic PW MPLS Control Word (PWMCW) defined in
   [RFC4385].

Yes, but why not the Preferred CW?

4.1.  DetNet Over MPLS Encapsulation Components

   The LSP used to forward the DetNet packet may be of any type (MPLS-
   LDP, MPLS-TE, MPLS-TP [RFC5921], or MPLS-SR
   [I-D.ietf-spring-segment-routing-mpls]).

I am not sure of the value of this statement for an "MPLS Dataplane" document.
Further, are these "LSP Types" and if so where are the different types
ennumerated? Does this mean that static binding LSPs and BGP signaled cannto be
used? T-LDP does not work? "SDN Assigned"? I recommend removing this, since it
can confuse and does not add much.

4.3.  OAM Indication

It is important to have the OAM Indication, but what type of OAM packets can
run on top of this AcH? I found it interesting that for example there is not
reference or citation to RFC 8029.

Nits:

2.2.  Abbreviations

   The following abbreviations are used in this document:

Many of these abbreviations are well-known, many others have authoritative
definitions and expansions. I believe this section should point to the
appropriate RFCs for LSR, CW, PE, OAM, etc...

Also, interesting, this section does not expand LSE, and I think it should use
it.

4.6.1.  Class of Service

Should this include "and TTL" in the title? I was looking for TTL specs in the
Table of Contents but could not find it.

9.2.  Informative References

Are all the "draft-ietf-detnet-*" really Informative?

Also, outdated reference: draft-ietf-spring-segment-routing-mpls has been
published as RFC 8660

   [RFC8655]  Finn, N., Thubert, P., Varga, B., and J. Farkas,
              "Deterministic Networking Architecture", RFC 8655,
              DOI 10.17487/RFC8655, October 2019,
              <https://www.rfc-editor.org/info/rfc8655>.

And is this also Informational?

Thank you!

Carlos Pignataro.

---

From: Stewart Bryant <[email-masked]>
Date: Tue, 24 Dec 2019 14:26:03 +0000

> On 24 Dec 2019, at 00:03, Carlos Pignataro via Datatracker <[email-masked]> wrote:
> 
> 

Hi Carlos

Thanks for the review. Just picking up a couple of points at this stage,

The PCW only supports a 16bit sequence number and it has the skip zero auto-signalling of active S/N feature.

This was a problem for DetNet because:

- We were worried about S/N rollover frequency in some applications and so we wanted the option of a larger S/N.

- We wanted to have the option to propagate the S/N from the payload to the transport to simplify the implementation in some cases. These applications have a non-skip zero S/N. Skip zero is an irritation to implement and we should probably have signalled in in PWs.

As you note in is only a preferred design for PWs, DetNet is not constrained by that and there were good reasons to adopt this alternate approach,

> can confuse and does not add much.

I think it just needs a “for example” and I think that it needs to be made clear that the design is not restricted to a single method of establishing an LSP nor to the characteristics and constraints that go with those LSPs.

> reference or citation to RFC 8029.

Work has started on OAM, for example draft-mirsky-detnet-mpls-oam-00

The OAM for DetNet will be more complex than the OAM for a classical P2P or P2MP LSP (or PW) because of the PREOF function. There is nothing in the data plane that precludes us using on of the existing OAM indicators (GAL or 0001 ACH), but I think that it is important to thing through the subtleties. Thus I think it is OK to make progress on the elements of the data plane that we can nail down, and leave. The OAM as follow-up work.

> Also, outdated reference: draft-ietf-spring-segment-routing-mpls has been

This will get picked up on the next resin as part of the Nits check.

Best regards

Stewart

---

From: Alexander Vainshtein <[email-masked]>
Date: Tue, 24 Dec 2019 14:35:10 +0000

Stewart, Carlos and all,
I understand the concerns with the 16-bit space for sequence numbers and the skip-zero approach taken by RFC 4385 (presumably, for compatibility with the early Martini drafts that have already been implemented). And it was quite convenient to turn off sequencing in PWs simply by setting SN to zero,

(The TDM PWs that MUST use sequence numbers because they MUST detect lost packets and compensate the lost payload use the entire 16-bit SN space).

But  I think that the draft should clearly articulate these considerations and also provide a definition of in-order and out-of-order packets. I have not found any of these things in the draft – did I miss something?

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]

From: rtg-dir <[email-masked]> On Behalf Of Stewart Bryant
Sent: Tuesday, December 24, 2019 4:26 PM
To: Carlos Pignataro <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [RTG-DIR] Rtgdir last call review of draft-ietf-detnet-mpls-04

On 24 Dec 2019, at 00:03, Carlos Pignataro via Datatracker <[email-masked]<mailto:[email-masked]>> wrote:

Hi Carlos

4.3.  OAM Indication

Best regards

Stewart

___________________________________________________________________________

This e-mail message is intended for the recipient only and contains information which is 
CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this 
transmission in error, please inform us by e-mail, phone or fax, and then delete the original 
and all copies thereof.
___________________________________________________________________________

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Tue, 24 Dec 2019 21:15:50 +0000

Hi, Stewart,

> 2019/12/24 午前9:26、Stewart Bryant <[email-masked]>のメール:
> 
> 
> 
> Thanks for the review.

Anytime!

> Just picking up a couple of points at this stage,

Sure, happy to follow-up on the rest at a later time.

> As you note in is only a preferred design for PWs, DetNet is not constrained by that and there were good reasons to adopt this alternate approach,

My main point is that, all that you say above, is not in the draft. The spec seems underspecified — including what’s in-order, out-of-order, which specific application layer (or some higher layer) sequencing schemes might map to, etc.

> I think it just needs a “for example” and I think that it needs to be made clear that the design is not restricted to a single method of establishing an LSP nor to the characteristics and constrain…

It would be a good start to made that clear and qualify the list. Still, what are “LSP Types”? Does it really add to ennumerate some and not others, even if “for-example”ing it?

> The OAM for DetNet will be more complex than the OAM for a classical P2P or P2MP LSP (or PW) because of the PREOF function. There is nothing in the data plane that precludes us using on of the exis…

I believe being explicit rather than implicit about scoping things out adds to clarity.

Do you expect an equal number of DetNet documents concerning themselves with OAM, as there are dataplane docs?

> This will get picked up on the next resin as part of the Nits check.

Thanks!

Happy Holidays :-)

Carlos.